#! /usr/bin/perl -w

#this should read in a file of gi numbers and extract the sequences from the specified databases.

if((scalar @ARGV)<2){
    print "You need to provide at least name_file and database(s) to search\n";
    exit(1);
}
$namefilename= shift @ARGV;
@databases=@ARGV;

open (INFILE,"< $namefilename")or die "unable to open $namefilename for reading\n";
%namehash=();
print STDERR "reading from $namefilename\n";
while ($inline=<INFILE>){
    if($inline=~/^\s*(\d+)\s*$/o){
	$namehash{$1}=1;
#	print STDERR "added $1\n";
    }elsif($inline=~/gi\|(\d+)/o){
	$namehash{$1}=1;
    }
}

print STDERR "".(scalar(keys %namehash))." sequences\n";
#now I have the names to extract in memory

%fullnames=();
$doubles=0;

foreach $dbname(@databases){
    print STDERR "searching database $dbname\n";
    open (DBFILE,"<$dbname")or die "unable to open $dbname for reading\n";
    $currname="";
    $currseq="";
    while ($inline=<DBFILE>){
	chomp $inline;
	if(length $inline==0){
	    next;
	}
	if($inline=~/>/){
	    @ginumbers= split /gi\|/ ,$currname;
	    $foundname=0;
	    #print STDERR "checking $currname\n";
	    foreach $giname(@ginumbers){
		#print STDERR "\t $giname\n";
		if($giname=~/^(\d+)\|/){
		    #print STDERR "\t$1\n";
		    if(defined $namehash{$1}){
			#print STDERR "\t found $1\n";
			delete $namehash{$1};
			if($foundname==1){
			    $doubles++;
			}
			$foundname=1;
		    }
		}
	    }
	    if($foundname==1){
		$fullnames{$currname}=$currseq;
	    }
	    $currname=$inline;
	    $currseq="";
	}else{
	    $currseq.=$inline;
	}
    }
}

print STDERR "".(scalar(keys %fullnames))." sequences found; $doubles identical sequences are not listed;\n";

if(scalar(keys %namehash)>0){
    print STDERR "The following ".(scalar (keys %namehash))." sequences were not found:\n";
    foreach $noname(keys %namehash){
	print STDERR "$noname\n";
    }
}

foreach $key(keys %fullnames){
    print "$key\n";
    print "$fullnames{$key}\n";
}
