#! /usr/bin/perl -w
use strict;

if(scalar @ARGV==0){
    die "usage: perl program_name fasta_or_clans_file cd-hit_clstr_file\n";
}

open(INFILE,"<$ARGV[1]") or die "ERROR< unable toopen $ARGV[1]\n";
my $refname="";
my $currname="";
my @arr=();
my %refhash=();
while(my $inline=<INFILE>){
    if($inline=~/>Cluster/o){
	if(length $refname>0){
	    my @tmparr=();#@arr is global, @tmparr is local
	    foreach my $val(@arr){
		push @tmparr,$val;
	    }
	    $refhash{$refname}=\@tmparr;
	}
	@arr=();
	$refname="";
    }else{
	if($inline=~/(gi\|\d+\|)/o){
	    $currname=$1;
	    if($inline=~/\s+\*\s*$/o){
		$refname=$currname;
		unshift @arr,$currname;
	    }else{
		push @arr,$currname;
	    }
	}
    }
}
close INFILE;

open(INFILE,"<$ARGV[0]") or die "ERROR, unable to open $ARGV[0] for reading\n";
while(my $inline=<INFILE>){
    if($inline=~/(gi\|\d+\|)/o){
	if(defined $refhash{$1}){
	    my @refarr=@{$refhash{$1}};
	    foreach my $val(@refarr){
		print $val."\n";
	    }
	}
    }
}
close INFILE;
